<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/Object.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/Object.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> * </span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 4 november 2008, 18:48</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef OBJECT_H_</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define OBJECT_H_</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef SYLPH_PUBLIC</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#undef SYLPH_PUBLIC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#endif </span><span class="comment">/* SYLPH_PUBLIC */</span>
<a name="l00029"></a>00029 <span class="preprocessor">#define SYLPH_PUBLIC</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#define SYLPH_BEGIN_NAMESPACE namespace Sylph {</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#define SYLPH_END_NAMESPACE }</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;cstddef&gt;</span>
<a name="l00035"></a>00035 
<a name="l00042"></a>00042 SYLPH_BEGIN_NAMESPACE
<a name="l00043"></a>00043 SYLPH_PUBLIC
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="keyword">struct </span>null {
<a name="l00046"></a>00046     null() {}
<a name="l00047"></a>00047     <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;
<a name="l00048"></a>00048     operator T*()<span class="keyword"> const </span>{
<a name="l00049"></a>00049     <span class="keywordflow">return</span> 0;
<a name="l00050"></a>00050     }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <span class="keyword">template</span>&lt;<span class="keyword">class</span> C, <span class="keyword">class</span> T&gt;
<a name="l00053"></a>00053     operator T C::*()<span class="keyword"> const </span>{
<a name="l00054"></a>00054     <span class="keywordflow">return</span> 0;
<a name="l00055"></a>00055     }
<a name="l00056"></a>00056 <span class="keyword">private</span>:
<a name="l00057"></a>00057     null(<span class="keyword">const</span> null&amp;);
<a name="l00058"></a>00058     null&amp; operator=(<span class="keyword">const</span> null&amp;);
<a name="l00059"></a>00059     <span class="keywordtype">void</span> operator&amp;() <span class="keyword">const</span>;
<a name="l00060"></a>00060 };
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="keyword">static</span> <span class="keyword">struct </span>null null;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="keyword">class </span>SerializationBuffer;
<a name="l00065"></a>00065 <span class="keyword">class </span>DeserializationBuffer;
<a name="l00066"></a>00066 
<a name="l00076"></a><a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed0">00076</a> <span class="keyword">enum</span> <a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed0" title="Used for LibSylph&amp;#39;s garbage collection.">GCPlacement</a> {
<a name="l00077"></a><a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed055c1fefbbd61326b8040063dfc20938a">00077</a>     <a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed055c1fefbbd61326b8040063dfc20938a" title="Use the garbage collector; this is the default.">UseGC</a>, 
<a name="l00078"></a><a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed04a096b0a5718f5a6dbb16f75c06714c6">00078</a>     <a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed04a096b0a5718f5a6dbb16f75c06714c6" title="Do not use the garbage collector for this specific object.">NoGC</a>, 
<a name="l00079"></a><a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed0a4af9fd92740c6e987fb58d30e8f0e3f">00079</a>     <a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed0a4af9fd92740c6e987fb58d30e8f0e3f" title="When the object you create does not contain pointers, use this to speed up GC --...">PointerFreeGC</a> 
<a name="l00082"></a>00082 };
<a name="l00083"></a>00083 
<a name="l00094"></a><a class="code" href="class_sylph_1_1_object.html">00094</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a> {
<a name="l00095"></a>00095 <span class="preprocessor">#ifndef SYLPH_DOXYGEN</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="keyword">public</span>:
<a name="l00097"></a>00097     <a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a>();
<a name="l00098"></a>00098     <span class="keyword">virtual</span> ~<a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a>();
<a name="l00099"></a>00099     <span class="keywordtype">void</span>* operator new( <span class="keywordtype">size_t</span> size);
<a name="l00100"></a>00100     <span class="keywordtype">void</span>* operator new( <span class="keywordtype">size_t</span> size, <a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed0" title="Used for LibSylph&amp;#39;s garbage collection.">GCPlacement</a> gcp);
<a name="l00101"></a>00101     <span class="keywordtype">void</span>* operator new( <span class="keywordtype">size_t</span> size, <span class="keywordtype">void</span> *p);
<a name="l00102"></a>00102     <span class="keywordtype">void</span> operator delete( <span class="keywordtype">void</span>* obj);
<a name="l00103"></a>00103     <span class="keywordtype">void</span> operator delete( <span class="keywordtype">void</span>*, <a class="code" href="namespace_sylph.html#392e3435758ffcbf741d6637f4695ed0" title="Used for LibSylph&amp;#39;s garbage collection.">GCPlacement</a>);
<a name="l00104"></a>00104     <span class="keywordtype">void</span> operator delete( <span class="keywordtype">void</span>*, <span class="keywordtype">void</span>*);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106     <span class="comment">// Arrays from Object are *never* gc'ed, and I recommend using Sylph::Array</span>
<a name="l00107"></a>00107     <span class="comment">// instead. Maybe we should document this somewhere?</span>
<a name="l00108"></a>00108     <span class="keywordtype">void</span>* operator new[](<span class="keywordtype">size_t</span> size);
<a name="l00109"></a>00109     <span class="keywordtype">void</span>* operator new[](<span class="keywordtype">size_t</span> size, <span class="keywordtype">void</span> *p);
<a name="l00110"></a>00110     <span class="keywordtype">void</span> operator delete[](<span class="keywordtype">void</span>* obj);
<a name="l00111"></a>00111     <span class="keywordtype">void</span> operator delete[](<span class="keywordtype">void</span>*, <span class="keywordtype">void</span>*);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="keyword">private</span>:
<a name="l00114"></a>00114     <span class="keyword">static</span> <span class="keywordtype">void</span> cleanup(<span class="keywordtype">void</span>* obj, <span class="keywordtype">void</span>* clientData);
<a name="l00115"></a>00115     <span class="keyword">static</span> <span class="keywordtype">bool</span> gc_inited;
<a name="l00116"></a>00116 <span class="preprocessor">#endif</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>};
<a name="l00118"></a>00118 
<a name="l00129"></a>00129 <span class="keyword">template</span>&lt;<span class="keyword">class </span>T, <span class="keyword">class</span>... Args&gt; T * <a class="code" href="namespace_sylph.html#63ddec6709f9855d2db98dc3ff22179b" title="Creates a new (non-LibSylph) object using the LibSylph garbage collection.">newgc</a>(<span class="keyword">const</span> Args&amp;... args);
<a name="l00130"></a>00130 
<a name="l00138"></a>00138 <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keywordtype">void</span> <a class="code" href="namespace_sylph.html#bbcdc8958d6c7815a8bbb4e322a0eef7" title="Deletes a (non-LibSylph) object that was previously allocated with LibSylph newgc()...">deletegc</a>(<span class="keyword">const</span> T * t);
<a name="l00139"></a>00139 <span class="comment">// Undocumented, do not use directly! </span>
<a name="l00140"></a>00140 <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keywordtype">void</span> cleanupgc(<span class="keywordtype">void</span> *obj, <span class="keywordtype">void</span> *displ);
<a name="l00141"></a>00141 SYLPH_END_NAMESPACE
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="preprocessor">#endif  </span><span class="comment">/* OBJECT_H_ */</span>
<a name="l00144"></a>00144 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
